/*
 *
 *
 */
#ifdef HAVE_CONFIG_H
#include "config.h"
#endif

#include "tdm_object.h"


struct tdm_object *tdm_object_new(const char *name, const size_t size)
{
	struct tdm_object *obj = NULL;

	if (!name || !name[0] || size < sizeof(struct tdm_object))
		return NULL;

	obj = calloc(size);
	if (!obj)
		return NULL;

	obj->type = TDM_OBJECT_NONE;

	obj->name = strdup(name);
	if (!obj->name) {
		free(obj);
		return NULL;
	}
	return obj;
}

/**
 * Rename object, use with care!
 */
tdm_status_t tdm_object_rename(struct tdm_object *obj, const char *name)
{
	char *old_name = NULL;
	char *new_name = NULL;

	if (!obj)
		return TDM_STATUS_GENERR;

	old_name = obj->name;

	new_name = strdup(name);
	if (!new_name)
		return TDM_STATUS_GENERR;

	obj->name = new_name;

	free(old_name);
	return TDM_STATUS_SUCCESS;
}

void tdm_object_destroy(struct tdm_object *obj)
{
	if (!obj)
		return;

	free(obj->name);
	free(obj);
}

