/*
 *
 *
 */
#ifndef __TDM_POLICY_H__
#define __TDM_POLICY_H__

struct tdm_policy_def {
	const char *name;
	const char *description;

	tdm_status_t (* policy_init)(struct tdm_policy *policy);
	tdm_status_t (* policy_destroy)(struct tdm_policy *policy);
	tdm_status_t (* policy_configure)(struct tdm_policy *policy);

	/* => struct tdm_spangroup_ops(?) */
	tdm_status_t (* group_add_span)(struct tdm_spangroup *group, struct tdm_span *span);
	tdm_status_t (* group_remove_span)(struct tdm_spangroup *group, struct tdm_span *span);
};

struct tdm_policy {
	struct tdm_object obj;

	struct tdm_policy_def *def;

	struct dlist_head policy_list;
};

tdm_status_t tdm_module_register_policy(struct tdm_module *mod, const struct tdm_policy_def *def);


#endif /* __TDM_POLICY_H__ */
