/*
 *
 *
 */
#ifndef __TDM_PORT_H__
#define __TDM_PORT_H__

struct tdm_port_ops {
	tdm_status_t (* port_open)(struct tdm_port *port);
	tdm_status_t (* port_close)(struct tdm_port *port);

	tdm_status_t (* port_add_channel)(struct tdm_port *port, struct tdm_channel *chan);
	tdm_status_t (* port_remove_channel)(struct tdm_port *port, struct tdm_channel *chan);
};

struct tdm_port {
	struct tdm_object obj;

	struct tdm_device   *device;
	struct tdm_port_ops *ops;

	struct dlist_head   port_list;

	unsigned int        nr_channels;
	struct dlist_head   channels;
};

struct tdm_port *tdm_object_to_port(struct tdm_object *obj);
struct tdm_module *tdm_port_get_module(struct tdm_port *port);

struct tdm_port *tdm_port_new(const char *name, const struct tdm_port_ops *ops);
tdm_status_t tdm_port_destroy(struct tdm_port *port);

int tdm_port_has_channel(struct tdm_port *port, struct tdm_channel *chan);

tdm_status_t tdm_port_add_channel(struct tdm_port *port, struct tdm_channel *chan);
tdm_status_t tdm_port_remove_channel(struct tdm_port *port, struct tdm_channel *chan);


#endif /* __TDM_PORT_H__ */
